SystemOrganization addCategory: #'GT-Examples-Dummies'!
SystemOrganization addCategory: 'GT-Examples-Dummies-Data'!
SystemOrganization addCategory: 'GT-Examples-Dummies-Tests'!

TestCase subclass: #GTDummyExamplesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Tests'!

!GTDummyExamplesTest methodsFor: 'accessing' stamp: 'StefanReichhart 7/12/2016 10:54'!
allExamplesDummiesProviders
	^ GTAbstractDummyExamples withAllSubclasses select: [ :each | 
		each isAbstract not ]! !

!GTDummyExamplesTest methodsFor: 'utils' stamp: 'StefanReichhart 7/12/2016 10:53'!
examplesInClasses: aSelector do: aBlock
	| classes examples |
	self shouldnt: [ classes  := (self perform: aSelector) ] raise: Error.
	self assert: classes notEmpty.
	classes do: [ :each |
		self shouldnt: [ examples := each gtExamples ] raise: Error.
		self assert: examples notEmpty.
		examples do: [ :example |
			self shouldnt: [ aBlock value: example ] raise: Error ] ]! !

!GTDummyExamplesTest methodsFor: 'accessing' stamp: 'StefanReichhart 7/12/2016 10:54'!
invalidExamplesDummiesProviders
	^ GTAbstractDummyExamples withAllSubclasses select: [ :each | 
		each isAbstract not 
			and: [ each isExpectedFailure ] ]! !

!GTDummyExamplesTest methodsFor: 'accessing' stamp: 'StefanReichhart 7/12/2016 10:54'!
recursiveExamplesDummiesProviders
	^ GTAbstractDummyExamples withAllSubclasses select: [ :each | 
		each isAbstract not 
			and: [ each isExpectedRecursion ] ]! !

!GTDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:26'!
testExists
	self examplesInClasses: #allExamplesDummiesProviders do: [ :example | 
		self assert: example exists ]! !

!GTDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:36'!
testInvalidDefinitions
	self examplesInClasses: #invalidExamplesDummiesProviders do: [ :example | 
		self assert: example exists.
		self deny: example isValid ]! !

!GTDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:26'!
testIsEquals
	self examplesInClasses: #allExamplesDummiesProviders do: [ :example | 
		self assert: (example = example) ]! !

!GTDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:26'!
testIsGTExample
	self examplesInClasses: #allExamplesDummiesProviders do: [ :example | 
		self assert: example isGTExample ]! !

!GTDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:26'!
testMatchesMethod
	self examplesInClasses: #allExamplesDummiesProviders do: [ :example | 
		self assert: (example matchesMethod: example method) ]! !

!GTDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:40'!
testRecursiveDefinitions
	self examplesInClasses: #recursiveExamplesDummiesProviders do: [ :example | 
		self assert: example exists.
		self assert: example hasValidArguments.
		self assert: example hasValidDependencies.
		self assert: (example method selector = #h or: [ example isValid not ]) ]! !

!GTDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 7/3/2016 20:26'!
testResult
	self examplesInClasses: #allExamplesDummiesProviders do: [ :example | 
		self shouldnt: [ example result ] raise: Error.
		self shouldnt: [ example returnValue ] raise: Error.
		self shouldnt: [ example result ] raise: Error.
		self shouldnt: [ example returnValue ] raise: Error. ]! !

!GTDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:26'!
testRun
	self examplesInClasses: #allExamplesDummiesProviders do: [ :example | 
		self shouldnt: [ example run ] raise: Error ]! !

TestCase subclass: #GTExampleResolverTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Tests'!

!GTExampleResolverTest methodsFor: 'asserting' stamp: 'StefanReichhart 1/29/2017 13:57'!
assertClass: aClassOrClassName meta: aBoolean resolvedAsClass: aClass 
	(GTExampleMethodResolver new 
		methodClassName: aClassOrClassName;
		meta: aBoolean;
		yourself) methodClassDo: [ :class | self assert: class == aClass ] ifNone: [ self assert: aClass isNil ].
	(GTExampleClassResolver new 
		theClassName: aClassOrClassName;
		meta: aBoolean;
		yourself) theClassDo: [ :class | self assert: class == aClass ] ifNone: [ self assert: aClass isNil ]! !

!GTExampleResolverTest methodsFor: 'asserting' stamp: 'StefanReichhart 1/29/2017 13:58'!
testResolve
	self assertClass: 'Object' meta: false resolvedAsClass: Object.
	self assertClass: 'Object' meta: true resolvedAsClass: Object class.
	
	self assertClass: #Object meta: false resolvedAsClass: Object.
	self assertClass: #Object meta: true resolvedAsClass: Object class.! !

!GTExampleResolverTest methodsFor: 'asserting' stamp: 'StefanReichhart 1/29/2017 13:58'!
testResolveWithCompatibility
	self assertClass: 'Object class' meta: false resolvedAsClass: Object class.
	self assertClass: 'Object class' meta: true resolvedAsClass: Object class.
	
	self assertClass: #'Object class' meta: false resolvedAsClass: Object class.
	self assertClass: #'Object class' meta: true resolvedAsClass: Object class.
	! !

GTExampleTestCase subclass: #GTExamplesDummiesTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Tests'!

!GTExamplesDummiesTestCase methodsFor: 'configuration' stamp: 'StefanReichhart 6/24/2016 12:04'!
packageNames
	^ { 'GT-Examples-Dummies' }! !

Object subclass: #CompanyEmployeeExample
	instanceVariableNames: 'e e2 c'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Data'!

!CompanyEmployeeExample methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 1/29/2017 15:33'!
doMore1: company
	<gtExample>
	<dependsOn: #employee:company:>
	
	self assert: company == c.
	self assert: company last == e.
	self assert: company size = 2.
	self assert: c size = 2.
	self assert: e size = 1.
	
	e add: #modified.
	c add: #modified.
	
	self assert: company == c.
	self assert: company second == e.
	self assert: company size = 3.
	self assert: c size = 3.
	self assert: e size = 2.
	self assert: company second == c second.
	self assert: e last = #modified.
	self assert: company last = #modified.
	
	^ company! !

!CompanyEmployeeExample methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 1/29/2017 15:44'!
doMore2: company employee: employee
	<gtExample>
	<dependsOn: #doMore1:>
	<dependsOnClass: #EmployeeExample selector: #e>
	
	self assert: company size = 3.
	self assert: company == c.
	self assert: company second == e.
	self assert: (e == employee) not.
	self assert: (e includes: employee) not.
	
	e2 := employee.
	
	^ company! !

!CompanyEmployeeExample methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 1/29/2017 15:44'!
doMore3: company1 company: company2 employee: employee
	<gtExample>
	<dependsOn: #doMore2:employee:>
	<dependsOnClass: #CompanyExample selector: #c>
	<dependsOnClass: #EmployeeExample selector: #e>
	
	self assert: company1 == c.
	self assert: (company2 == c) not.
	self assert: (company1 == company2) not.
	self assert: (employee == e) not.
	self assert: (employee == e2) not.
	self assert: (c includes: employee) not.! !

!CompanyEmployeeExample methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 1/29/2017 15:32'!
employee: employee company: company
	<gtExample>
	<dependsOnClass: #EmployeeExample selector: #e>
	<dependsOnClass: #CompanyExample selector: #c>
	
	self assert: e isNil.
	self assert: c isNil.
	
	e := employee.
	c := company.
	
	self assert: e == employee.
	self assert: c == company.
	
	c add: e.
	
	self assert: (c includes: e).
	
	^ c! !

Object subclass: #CompanyExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Data'!

!CompanyExample methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 1/29/2017 15:18'!
c
	<gtExample>
	^ OrderedCollection with: 'Company'! !

Object subclass: #EmployeeExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Data'!

!EmployeeExample methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 1/29/2017 15:23'!
e
  <gtExample>
  ^ OrderedCollection with: 'Employee'! !

Object subclass: #GTAbstractDummyExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Data'!

!GTAbstractDummyExamples class methodsFor: 'testing' stamp: 'StefanReichhart 7/12/2016 10:43'!
isAbstract
	^ self == GTAbstractDummyExamples ! !

!GTAbstractDummyExamples class methodsFor: 'testing' stamp: 'StefanReichhart 7/12/2016 10:43'!
isExpectedFailure
	^ false! !

!GTAbstractDummyExamples class methodsFor: 'testing' stamp: 'StefanReichhart 7/12/2016 10:43'!
isExpectedRecursion
	^ false! !

GTAbstractDummyExamples subclass: #GTDummyExampleProvider
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Data'!

!GTDummyExampleProvider methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 18:18'!
a
	<gtExample>
	^ GTDummyExampleSource new a " image this example would do something real about its source "! !

!GTDummyExampleProvider methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 18:18'!
b
	<gtExample>
	^ GTDummyExampleSource new b " image this example would do something real about its source "! !

!GTDummyExampleProvider methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:07'!
c: a c: b
	<gtExample>
	<dependsOn: #a>
	<dependsOn: #b>
	^ a | b! !

GTAbstractDummyExamples subclass: #GTDummyExampleWithAssertions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Data'!

!GTDummyExampleWithAssertions methodsFor: 'examples' stamp: 'AndreiChis 10/15/2015 11:59'!
a
	<gtExample>
	^ true! !

!GTDummyExampleWithAssertions methodsFor: 'examples' stamp: 'AliakseiSyrel 10/12/2015 09:48'!
b
	<gtExample>
	^ true! !

!GTDummyExampleWithAssertions methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:07'!
c: aBoolean c: anotherBoolean
	<gtExample>
	<dependsOn: #a>
	<dependsOn: #b>
	self assert: aBoolean = anotherBoolean.
	^ aBoolean & anotherBoolean! !

GTAbstractDummyExamples subclass: #GTDummyExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Data'!

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 11:31'!
a
	<gtExample>
	<label: 'Dummy #a'>
	<description: 'should return true'>
	
	^ true! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:07'!
b: aBoolean
	<gtExample>
	<label: 'Dummy #b:, depends #a'>
	<description: 'should return false'>
	<dependsOn: #a>
	
	^ aBoolean & false! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:09'!
c: aBoolean
	<gtExample>
	<label: 'Dummy #c:, depends #b:'>
	<description: 'should return true'>
	<dependsOn: #b:>
	
	^ aBoolean | true! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:09'!
d: anInteger
	<gtExample>
	<label: 'Dummy #d:, depends #c:'>
	<description: 'should raise an exception as the argument is not anInteger'>
	<dependsOn: #c:>
	<raises: #MessageNotUnderstood>
	
	^ 1 + anInteger! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:09'!
e: aString
	<gtExample>
	<label: 'Dummy #e:, depends #c:'>
	<description: 'should raise an exception as the argument is not aString'>
	<dependsOn: #c:>
	<raises: #Error>
	
	^ 'Hellow World', aString! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:09'!
f: aBoolean
	<gtExample>
	<label: 'Dummy #f:, depends: #c:'>
	<description: 'shouldnt raise any exception'>
	<dependsOn: #c:>
	
	self assert: aBoolean.
	^ aBoolean! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 12:58'!
g: aBoolean
	<gtExample>
	<label: 'Dummy #g, depends: #c'>
	<description: 'should raise a ZeroDivide'>
	<dependsOn: #c:>
	<raises: #ZeroDivide>
	
	self assert: aBoolean.
	^ 1/0! !

!GTDummyExamples class methodsFor: 'examples-failing' stamp: 'StefanReichhart 1/29/2017 14:09'!
h: aBoolean
	<gtExample>
	<label: 'Dummy #h, depends: #e:'>
	<description: 'shouldnt raise any exception, but dependency should'>
	<dependsOn: #e:>
	<noTest>
	
	^ aBoolean & false! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'AndreiChis 12/4/2015 15:11'!
i
	<gtExample>
	<label: 'Dummy #i'>
	<description: 'should raise ZeroDivide'>

	<raises: #ZeroDivide>
	^ 1/0! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'AndreiChis 12/4/2015 15:11'!
j
	<gtExample>
	<label: 'Dummy #j'>
	<description: 'should raise ZeroDivide'>
	<raises: #ZeroDivide>
	<raises: #AssertionFailure>

	1/0.	
	self assert: false! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 7/19/2016 14:32'!
k
	<gtExample>
	<label: 'Dummy #k'>
	<description: 'example with an icon'>
	<icon: #objects>

	^ nil! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 11:36'!
l
	<gtExample>
! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 11:37'!
m
	<gtExample>
	<label: 'Dummy #m'>
! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 11:38'!
n
	<gtExample>
	<label: 'Dummy #n'>
	<description: 'with label and description'>! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 11:38'!
o
	<gtExample>
	<description: 'with description only'>! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:09'!
p: aBoolean1 p: aBoolean2 p: aBoolean3
	<gtExample>
	<label: 'Dummy #p:p:p:, depends #a, #b:, #c:'>
	<description: 'with description only'>
	<dependsOn: #a>
	<dependsOn: #b:>
	<dependsOn: #c:>
	
	self assert: (aBoolean1 | aBoolean2 | aBoolean3).
	^ aBoolean1 | aBoolean2 | aBoolean3! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:09'!
q: aBoolean
	<gtExample>
	<description: 'with description only'>
	<dependsOn: #p:p:p:>
	
	self assert: aBoolean.
	^ aBoolean! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:09'!
r: aBoolean1 r: aBoolean2
	<gtExample>
	<label: 'Dummy #r:, depends #q: and p:p:p:'>
	<dependsOn: #p:p:p:>
	<dependsOn: #q:>
	
	self assert: aBoolean1 & aBoolean2.
	^ aBoolean1 & aBoolean2! !

!GTDummyExamples class methodsFor: 'examples-failing' stamp: 'StefanReichhart 1/29/2017 14:09'!
s: aBoolean
	<gtExample>
	<label: 'Dummy #s, invalid recursion'>
	<dependsOn: #s:>
	<noTest>
	
	^ aBoolean! !

!GTDummyExamples class methodsFor: 'examples-failing' stamp: 'StefanReichhart 1/29/2017 14:09'!
t: aBoolean
	<gtExample>
	<label: 'Dummy #t, invalid recursion'>
	<dependsOn: #s:>
	<noTest>
	
	^ aBoolean! !

!GTDummyExamples class methodsFor: 'examples-failing' stamp: 'StefanReichhart 1/29/2017 14:09'!
u: aBoolean
	<gtExample>
	<label: 'Dummy #u, invalid recursion'>
	<dependsOn: #v:>
	<noTest>
	
	^ aBoolean! !

!GTDummyExamples class methodsFor: 'examples-failing' stamp: 'StefanReichhart 1/29/2017 14:09'!
v: aBoolean
	<gtExample>
	<label: 'Dummy #v, invalid recursion'>
	<dependsOn: #u:>
	<noTest>
	
	^ aBoolean! !

!GTDummyExamples class methodsFor: 'examples-failing' stamp: 'StefanReichhart 1/29/2017 14:09'!
w: aBoolean
	<gtExample>
	<label: 'Dummy #w'>
	<dependsOn: #z:>
	<noTest>
	
	^ aBoolean! !

!GTDummyExamples class methodsFor: 'examples-failing' stamp: 'StefanReichhart 1/29/2017 14:09'!
x: aBoolean
	<gtExample>
	<label: 'Dummy #x:, depends: w:'>
	<dependsOn: #w:>
	<noTest>
	
	^ aBoolean! !

!GTDummyExamples class methodsFor: 'examples-failing' stamp: 'StefanReichhart 1/29/2017 14:09'!
y: aBoolean1 y: aBoolean2
	<gtExample>
	<label: 'Dummy #y:y:, depends: #x: and #w:'>
	<dependsOn: #x:>
	<dependsOn: #w:>
	<noTest>
	
	^ aBoolean1 & aBoolean2! !

!GTDummyExamples class methodsFor: 'examples-failing' stamp: 'StefanReichhart 1/29/2017 14:10'!
z: aBoolean
	<gtExample>
	<label: 'Dummy #z, depends: #y:y:'>
	<dependsOn: #y:y:>
	<noTest>
	
	^ aBoolean! !

GTAbstractDummyExamples subclass: #GTDummyExamplesInvalid
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Data'!

!GTDummyExamplesInvalid class methodsFor: 'examples' stamp: 'StefanReichhart 9/26/2015 11:27'!
a: anObject
	<gtExample>
	<label: 'Dummy #a:'>
	<description: 'argument defined / dependency missing'>
	<noTest>! !

!GTDummyExamplesInvalid class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:10'!
b
	<gtExample>
	<label: 'Dummy #b'>
	<description: 'existing dependency defined / argument missing'>
	<dependsOn: #a>
	<noTest>
	! !

!GTDummyExamplesInvalid class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:10'!
c: anObject1 c: anObject2
	<gtExample>
	<label: 'Dummy #c:c:'>
	<description: 'non-existing dependencies defined, all arguments defined'>
	<dependsOn: #a>
	<dependsOn: #b:>
	<noTest>
	! !

!GTDummyExamplesInvalid class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:10'!
d
	<gtExample>
	<label: 'Dummy #c:c:'>
	<description: 'non-existing dependencies defined, all arguments missing'>
	<dependsOn: #a>
	<dependsOn: #b:>
	<noTest>
	! !

!GTDummyExamplesInvalid class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:10'!
e: anObject
	<gtExample>
	<label: 'Dummy #e:'>
	<description: 'not enough dependencies defined'>
	<dependsOn: #a:>
	<dependsOn: #b>
	<noTest>
	! !

!GTDummyExamplesInvalid class methodsFor: 'examples' stamp: 'StefanReichhart 7/13/2016 18:26'!
f
	<gtExample>
	<label: 'Dummy #f'>
	<description: 'non existing after method'>
	<after: #afterF> " !! "
	<noTest>
	! !

!GTDummyExamplesInvalid class methodsFor: 'examples' stamp: 'StefanReichhart 7/13/2016 18:32'!
g
	<gtExample>
	<label: 'Dummy #f'>
	<description: 'non existing after method'>
	<after: nil>
	<noTest>
	! !

!GTDummyExamplesInvalid class methodsFor: 'testing' stamp: 'StefanReichhart 7/12/2016 10:55'!
isExpectedFailure
	^ true! !

GTAbstractDummyExamples subclass: #GTDummyExamplesOnBothSides
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Data'!

!GTDummyExamplesOnBothSides class methodsFor: 'examples' stamp: 'StefanReichhart 7/4/2016 12:58'!
classSideA
	<gtExample>
	^ 2! !

!GTDummyExamplesOnBothSides class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:10'!
classSideB: a
	<gtExample>
	<dependsOn: #classSideA>
	self assert: a = 2.
	^ a + 2! !

!GTDummyExamplesOnBothSides class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:10'!
classSideC: a classSideC: b
	<gtExample>
	<dependsOn: #classSideA>
	<dependsOnClass: #'GTDummyExamplesOnBothSides class' selector: #classSideB:>
	self assert: a = 2.
	self assert: b = 4.
	^ a + b - 3! !

!GTDummyExamplesOnBothSides class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:12'!
classSideD: instanceSideC
	<gtExample>
	<dependsOnClass: #GTDummyExamplesOnBothSides selector: #c:c:>
	self assert: instanceSideC = 9.
	^ instanceSideC! !

!GTDummyExamplesOnBothSides methodsFor: 'examples' stamp: 'StefanReichhart 7/4/2016 12:55'!
a
	<gtExample>
	^ 1! !

!GTDummyExamplesOnBothSides methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:10'!
b: a
	<gtExample>
	<dependsOn: #a>
	self assert: a = 1.
	^ a + 1! !

!GTDummyExamplesOnBothSides methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:10'!
c: a c: b
	<gtExample>
	<dependsOn: #a>
	<dependsOnClass: #GTDummyExamplesOnBothSides selector: #b:>
	self assert: a = 1.
	self assert: b = 2.
	^ a + b + 6! !

!GTDummyExamplesOnBothSides methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:12'!
d: classSideC
	<gtExample>
	<dependsOnClass: #'GTDummyExamplesOnBothSides class' selector: #classSideC:classSideC:>
	self assert: classSideC = 3.
	^ classSideC! !

GTAbstractDummyExamples subclass: #GTDummyExamplesPragmas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Data'!

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 12:37'!
a
	<gtExample>
! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 12:38'!
b
	<gtExample>
	<label: 'Dummy #b with a label'>
! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 12:39'!
c
	<gtExample>
	<description: 'Dummy #c without label but with a description'>
! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 12:38'!
d
	<gtExample>
	<label: 'Dummy #d'>
	<description: 'Dummy #d with label and description'>
! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 12:43'!
e
	<gtExample>
	<label: 'Dummy #e'>
	<description: 'Dummy #e with an icon (default behaviour)'>
	<icon: #pageIcon>
! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 12:43'!
f
	<gtExample>
	<label: 'Dummy #f'>
	<description: 'Dummy #f with an icon provided by the current theme'>
	<iconThemeSelector: #refreshIcon>
! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 12:41'!
g
	<gtExample>
	<label: 'Dummy #g'>
	<description: 'Dummy #g with an icon provided by the current provider'>
	<iconSelector: #iconForG>
! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 12:48'!
h
	<gtExample>
	<label: 'Dummy #h'>
	<description: 'Dummy #h with an icon based on the given base64 string'>
	<iconBase64: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAADrSURBVDjLY/z//z8DJYCJgUIw
yAwoPZHJBsS7STGABY1/9e+fvzKkGMAIiwWgzRfF2ST0/vz5w/Dw/UOGXz9/M/z6AcK/GH4C
MZj+jmCD5C70X2VkgWo+KcYqrqfArcTw598fBhluOTD9++9fIP7N8PsfEP/9AxUD0b8ZVq9c
i/AC0Nm//zD+Yfj19xdY0R+got9gxb8RNNQAkNyf/0CxX39QvZC5M+68MJuIAQczJ8PDlw8Z
Xr9/g9XZIK+BNP/5/Yfh/sJHjIzIKTF2VchNoEI5oAbHDWk7TpAcjUDNukDNB4nVjOKFEZwX
AOOhu7x6WtPJAAAAAElFTkSuQmCC'>
! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 12:50'!
i
	<gtExample>
	<label: 'Dummy #i'>
	<description: 'Dummy #i with an icon based on the given bytes'>
	<iconBytes: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)>
! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 12:42'!
iconForG
	^ Smalltalk ui icons bookIcon! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 12:52'!
iconForJ
	^ Smalltalk ui icons bookIcon ! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'AndreiChis 12/4/2015 15:12'!
j
	<gtExample>
	<label: 'Dummy #i'>
	<description: 'Dummy #i with an icon based on the given bytes'>
	<iconClass: #GTDummyExamplesPragmas selector: #iconForJ>
! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'AndreiChis 12/4/2015 15:12'!
k
	<gtExample>
	<label: 'Dummy #k'>
	<description: 'Dummy #k, with subject Boolean (returns true)'>
	<subject: #Boolean>
	
	^ true & ( false == false ) | true | ( false ~= true )! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'AndreiChis 12/4/2015 15:12'!
l
	<gtExample>
	<label: 'Dummy #l'>
	<description: 'Dummy #l, with subjects Boolean and Number (returns true)'>
	<subject: #Boolean>
	<subject: #Number>
	
	^ true & ( 1 == 1 ) & (1 + 1 = 2)! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 13:00'!
m
	<gtExample>
	<label: 'Dummy #m'>
	<description: 'Dummy #m, with subjects Boolean and Number (returns true)'>
	<subjectsAll: 'Boolean Number, Date . Duration ; Float'>
	
	^ true & ( 1 == 1 ) & ( Date today = Date today ) & ( Duration seconds: 0 ) isZero & Float pi isFloat! !

GTAbstractDummyExamples subclass: #GTDummyExamplesRecursive
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Data'!

!GTDummyExamplesRecursive class methodsFor: 'examples 1' stamp: 'StefanReichhart 1/29/2017 14:10'!
a: aBoolean
	<gtExample>
	<label: 'Dummy #a:, depends: #a:'>
	<dependsOn: #a:> " loop "
	<noTest>
	
	^ aBoolean! !

!GTDummyExamplesRecursive class methodsFor: 'examples 1' stamp: 'StefanReichhart 1/29/2017 14:10'!
b: aBoolean
	<gtExample>
	<label: 'Dummy #b:, depends: #a:'>
	<dependsOn: #a:>
	<noTest>
	
	^ aBoolean! !

!GTDummyExamplesRecursive class methodsFor: 'examples 1' stamp: 'StefanReichhart 1/29/2017 14:10'!
c: aBoolean
	<gtExample>
	<label: 'Dummy #c:, depends: #b:'>
	<dependsOn: #b:>
	<noTest>
	
	^ aBoolean! !

!GTDummyExamplesRecursive class methodsFor: 'examples 2' stamp: 'StefanReichhart 1/29/2017 14:10'!
d: aBoolean
	<gtExample>
	<label: 'Dummy #d:, depends: #f:'>
	<dependsOn: #f:> " loop "
	<noTest>
	
	^ aBoolean! !

!GTDummyExamplesRecursive class methodsFor: 'examples 2' stamp: 'StefanReichhart 1/29/2017 14:10'!
e: aBoolean
	<gtExample>
	<label: 'Dummy #e:, depends: #d:'>
	<dependsOn: #d:>
	<noTest>
	
	^ aBoolean! !

!GTDummyExamplesRecursive class methodsFor: 'examples 2' stamp: 'StefanReichhart 1/29/2017 14:11'!
f: aBoolean
	<gtExample>
	<label: 'Dummy #f:, depends: #e:'>
	<dependsOn: #e:>
	<noTest>
	
	^ aBoolean! !

!GTDummyExamplesRecursive class methodsFor: 'examples 3' stamp: 'StefanReichhart 1/29/2017 14:11'!
g: aBoolean1 g: aBoolean2
	<gtExample>
	<label: 'Dummy #g:g:, depends: #i:i: and #h'>
	<dependsOn: #i:i:>
	<dependsOn: #h>
	<noTest>
	
	^ aBoolean1 & aBoolean2! !

!GTDummyExamplesRecursive class methodsFor: 'examples 3' stamp: 'StefanReichhart 9/26/2015 11:27'!
h
	<gtExample>
	<label: 'Dummy #h, (the only successful example in this example provider)'>
	<noTest>
	
	^ true! !

!GTDummyExamplesRecursive class methodsFor: 'examples 3' stamp: 'StefanReichhart 1/29/2017 14:11'!
i: aBoolean1 i: aBoolean2
	<gtExample>
	<label: 'Dummy #i:i:, depends: #j: and #h:'>
	<dependsOn: #j:>
	<dependsOn: #h>
	<noTest>
	
	^ aBoolean1 & aBoolean2! !

!GTDummyExamplesRecursive class methodsFor: 'testing' stamp: 'StefanReichhart 7/12/2016 10:56'!
isExpectedRecursion
	^ true! !

!GTDummyExamplesRecursive class methodsFor: 'examples 3' stamp: 'StefanReichhart 1/29/2017 14:11'!
j: aBoolean1
	<gtExample>
	<label: 'Dummy #j:, depends: #g:'>
	<dependsOn: #g:g:> " loop "
	<noTest>
	
	^ aBoolean1! !

!GTDummyExamplesRecursive class methodsFor: 'examples 4' stamp: 'StefanReichhart 1/29/2017 14:11'!
k: aBoolean1 k: aBoolean2
	<gtExample>
	<label: 'Dummy #k:k:, depends: #m:m: and #l:l:'>
	<dependsOn: #l:l:>
	<dependsOn: #m:m:>
	<noTest>
	
	^ aBoolean1 & aBoolean2! !

!GTDummyExamplesRecursive class methodsFor: 'examples 4' stamp: 'StefanReichhart 1/29/2017 14:09'!
l: aBoolean1 l: aBoolean2
	<gtExample>
	<label: 'Dummy #l:l:, depends: #k:k: and #n:'>
	<dependsOn: #k:k:> " loop "
	<dependsOn: #n:>
	<noTest>
	
	^ aBoolean1 & aBoolean2! !

!GTDummyExamplesRecursive class methodsFor: 'examples 4' stamp: 'StefanReichhart 1/29/2017 14:09'!
m: aBoolean1 m: aBoolean2
	<gtExample>
	<label: 'Dummy #m:m:, depends: #l:l: and #n:'>
	<dependsOn: #l:l:>
	<dependsOn: #n:>
	<noTest>
	
	^ aBoolean1 & aBoolean2! !

!GTDummyExamplesRecursive class methodsFor: 'examples 4' stamp: 'StefanReichhart 1/29/2017 14:08'!
n: aBoolean1
	<gtExample>
	<label: 'Dummy #n:, depends: #k:k:'>
	<dependsOn: #k:k:> " loop "
	<noTest>
	
	^ aBoolean1! !

!GTDummyExamplesRecursive class methodsFor: 'examples 5' stamp: 'StefanReichhart 1/29/2017 14:08'!
o: aBoolean1
	<gtExample>
	<label: 'Dummy #o:, depends: #p:'>
	<dependsOn: #p:> 
	<noTest>
	
	^ aBoolean1! !

!GTDummyExamplesRecursive class methodsFor: 'examples 5' stamp: 'StefanReichhart 1/29/2017 14:08'!
p: aBoolean1
	<gtExample>
	<label: 'Dummy #p:, depends: #o:'>
	<dependsOn: #o:> " loop " 
	<noTest>
	
	^ aBoolean1! !

!GTDummyExamplesRecursive class methodsFor: 'examples 6' stamp: 'StefanReichhart 1/29/2017 14:08'!
q: aBoolean1 q: aBoolean2
	<gtExample>
	<label: 'Dummy #q:q:, depends: #r: and #r:'>
	<dependsOn: #r:> 
	<dependsOn: #r:> 
	<noTest>
	
	^ aBoolean1! !

!GTDummyExamplesRecursive class methodsFor: 'examples 6' stamp: 'StefanReichhart 1/29/2017 14:08'!
r: aBoolean1
	<gtExample>
	<label: 'Dummy #r:, depends: #s:'>
	<dependsOn: #s:> 
	<noTest>
		
	^ aBoolean1! !

!GTDummyExamplesRecursive class methodsFor: 'examples 6' stamp: 'StefanReichhart 1/29/2017 14:08'!
s: aBoolean1
	<gtExample>
	<label: 'Dummy #s:, depends: #q:q:'>
	<dependsOn: #q:q:> " loop " 
	<noTest>
		
	^ aBoolean1! !

!GTDummyExamplesRecursive class methodsFor: 'examples 7' stamp: 'StefanReichhart 1/29/2017 14:08'!
t: aBoolean1 t: aBoolean2
	<gtExample>
	<label: 'Dummy #t:t:, depends: #u:u: and #v:'>
	<dependsOn: #u:u:> 
	<dependsOn: #v:> 
	<noTest>
		
	^ aBoolean1 & aBoolean2! !

!GTDummyExamplesRecursive class methodsFor: 'examples 7' stamp: 'StefanReichhart 1/29/2017 14:08'!
u: aBoolean1 u: aBoolean2
	<gtExample>
	<label: 'Dummy #u:u:, depends: #v: and #w:w:'>
	<dependsOn: #w:w:> 
	<dependsOn: #v:> 
	<noTest>
	
	^ aBoolean1 & aBoolean2! !

!GTDummyExamplesRecursive class methodsFor: 'examples 7' stamp: 'StefanReichhart 1/29/2017 14:08'!
v: aBoolean1
	<gtExample>
	<label: 'Dummy #v:, depends: #x:'>
	<dependsOn: #x:> 
	<noTest>
		
	^ aBoolean1! !

!GTDummyExamplesRecursive class methodsFor: 'examples 7' stamp: 'StefanReichhart 1/29/2017 14:08'!
w: aBoolean1 w: aBoolean2
	<gtExample>
	<label: 'Dummy #w:w:, depends: #x: and #y:'>
	<dependsOn: #x:> 
	<dependsOn: #y:> 
	<noTest>
		
	^ aBoolean1 & aBoolean2! !

!GTDummyExamplesRecursive class methodsFor: 'examples 7' stamp: 'StefanReichhart 1/29/2017 14:08'!
x: aBoolean1
	<gtExample>
	<label: 'Dummy #x:, depends: #y:'>
	<dependsOn: #y:> 
	<noTest>
	
	^ aBoolean1! !

!GTDummyExamplesRecursive class methodsFor: 'examples 7' stamp: 'StefanReichhart 1/29/2017 14:08'!
y: aBoolean1
	<gtExample>
	<label: 'Dummy #y:, depends: #z:'>
	<dependsOn: #z:> 
	<noTest>
	
	^ aBoolean1! !

!GTDummyExamplesRecursive class methodsFor: 'examples 7' stamp: 'StefanReichhart 1/29/2017 14:08'!
z: aBoolean1
	<gtExample>
	<label: 'Dummy #z:, depends: #t:t:'>
	<dependsOn: #t:t:>  " loop "
	<noTest>
	
	^ aBoolean1! !

GTAbstractDummyExamples subclass: #GTDummyExamplesWithAfter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Data'!

!GTDummyExamplesWithAfter class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 1/29/2017 14:08'!
a: b
	<gtExample>
	<dependsOn: #b:>
	<after: #afterA>
	" START -> C B A -> afterA -> afterB -> afterC -> END "
	
	self assert: (self gtExampleContext includesKey: #c).
	self assert: (self gtExampleContext includesKey: #c2).
	self assert: (self gtExampleContext includesKey: #b).
	self assert: (self gtExampleContext includesKey: #b2).
	
	self gtExampleContext at: #a put: #a.
	self gtExampleContext at: #a2 put: #a2.! !

!GTDummyExamplesWithAfter class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 6/24/2016 12:25'!
afterA
	self assert: (self gtExampleContext includesKey: #a).
	self assert: (self gtExampleContext includesKey: #b).
	self assert: (self gtExampleContext includesKey: #b2).
	self assert: (self gtExampleContext includesKey: #c).
	self assert: (self gtExampleContext includesKey: #c2).
	
	self gtExampleContext removeKey: #a.
	
	self assert: (self gtExampleContext includesKey: #a) not.
	self assert: (self gtExampleContext includesKey: #b).
	self assert: (self gtExampleContext includesKey: #b2).
	self assert: (self gtExampleContext includesKey: #c).
	self assert: (self gtExampleContext includesKey: #c2).! !

!GTDummyExamplesWithAfter class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 6/24/2016 12:24'!
afterB
	self assert: (self gtExampleContext includesKey: #c).
	self assert: (self gtExampleContext includesKey: #c2).
	self assert: (self gtExampleContext includesKey: #b).
	self assert: (self gtExampleContext includesKey: #b2).
	
	self gtExampleContext removeKey: #b.
	
	self assert: (self gtExampleContext includesKey: #b) not.
	self assert: (self gtExampleContext includesKey: #b2).
	self assert: (self gtExampleContext includesKey: #c).
	self assert: (self gtExampleContext includesKey: #c2).! !

!GTDummyExamplesWithAfter class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 6/24/2016 12:10'!
afterC	
	self assert: (self gtExampleContext includesKey: #c).
	
	self gtExampleContext removeKey: #c.
	
	self assert: (self gtExampleContext includesKey: #c) not.
	self assert: (self gtExampleContext includesKey: #c2).! !

!GTDummyExamplesWithAfter class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 1/29/2017 14:08'!
b: c
	<gtExample>
	<dependsOn: #c>
	<after: #afterB>
	" START -> C B -> afterB -> afterC -> END "
	
	self assert: (self gtExampleContext includesKey: #c).
	self assert: (self gtExampleContext includesKey: #c2).
	
	self gtExampleContext at: #b put: #b.
	self gtExampleContext at: #b2 put: #b2.
	
	self assert: ((self gtExampleContext at: #b) = #b).
	self assert: ((self gtExampleContext at: #b2) = #b2).
	
	^ #b2! !

!GTDummyExamplesWithAfter class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 6/24/2016 12:11'!
c
	<gtExample>
	<after: #afterC>
	" START -> C -> afterC -> END "
	
	self gtExampleContext at: #c put: #c.
	self gtExampleContext at: #c2 put: #c2.
	
	self assert: ((self gtExampleContext at: #c) = #c).
	self assert: ((self gtExampleContext at: #c2) = #c2).
	
	^ #c2! !

GTAbstractDummyExamples subclass: #GTDummyExamplesWithAfter2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Data'!

!GTDummyExamplesWithAfter2 class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 1/29/2017 14:08'!
a: b
	<gtExample>
	<dependsOn: #b:>
	<after: #afterA:>
	" START -> C B A -> afterA -> afterB -> afterC -> END "
	
	self assert: (self gtExampleContext includesKey: #c).
	self assert: (self gtExampleContext includesKey: #b).
	
	self gtExampleContext at: #a put: #a.
	self assert: (self gtExampleContext includesKey: #a).
	
	^ #a2! !

!GTDummyExamplesWithAfter2 class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 6/24/2016 11:56'!
afterA: arg
	self assert: arg = #a2.
	
	self assert: (self gtExampleContext includesKey: #b).
	self assert: (self gtExampleContext includesKey: #c).
	
	self gtExampleContext removeKey: #a.
	
	self assert: (self gtExampleContext includesKey: #a) not.
	self assert: self gtExampleContext notEmpty! !

!GTDummyExamplesWithAfter2 class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 6/24/2016 11:56'!
afterB: arg
	self assert: arg = #b2.
	
	self assert: (self gtExampleContext includesKey: #a) not.
	self assert: (self gtExampleContext includesKey: #c).
	
	self gtExampleContext removeKey: #b.
	
	self assert: (self gtExampleContext includesKey: #b) not.
	self assert: self gtExampleContext notEmpty! !

!GTDummyExamplesWithAfter2 class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 6/24/2016 12:21'!
afterC: arg
	self assert: arg = #c2.
	
	self assert: (self gtExampleContext includesKey: #a) not.
	self assert: (self gtExampleContext includesKey: #b) not.
	
	self gtExampleContext removeKey: #c.
	
	self assert: (self gtExampleContext includesKey: #c) not.
	self assert: self gtExampleContext isEmpty! !

!GTDummyExamplesWithAfter2 class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 1/29/2017 14:08'!
b: c
	<gtExample>
	<dependsOn: #c>
	<after: #afterB:>
	" START -> C B -> afterB -> afterC -> END "
	
	self assert: (self gtExampleContext includesKey: #c).
	
	self gtExampleContext at: #b put: #b.
	self assert: ((self gtExampleContext at: #b) = #b).
	
	^ #b2! !

!GTDummyExamplesWithAfter2 class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 5/13/2016 11:24'!
c
	<gtExample>
	<after: #afterC:>
	" START -> C -> afterC -> END "
	
	self gtExampleContext at: #c put: #c.
	self assert: ((self gtExampleContext at: #c) = #c).
	
	^ #c2! !

GTAbstractDummyExamples subclass: #GTDummyExamplesWithContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Data'!

!GTDummyExamplesWithContext class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 3/28/2016 19:01'!
a
	<gtExample>
	self assert: self gtExampleContext notNil.
	self gtExampleContext at: #a put: #a.
	^ self gtExampleContext ! !

!GTDummyExamplesWithContext class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 1/29/2017 14:08'!
b: a c: c
	<gtExample>
	<dependsOn: #a>
	<dependsOn: #c>
	self assert: self gtExampleContext notNil.
	self assert: a == self gtExampleContext.
	self assert: c == self gtExampleContext.
	self assert: (self gtExampleContext at: #a) = #a.
	self assert: (self gtExampleContext at: #c) = #c.! !

!GTDummyExamplesWithContext class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 3/28/2016 19:01'!
c
	<gtExample>
	self assert: self gtExampleContext notNil.
	self gtExampleContext at: #c put: #c.
	^ self gtExampleContext ! !

GTAbstractDummyExamples subclass: #GTDummyExamplesWithCustomExtensions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Data'!

!GTDummyExamplesWithCustomExtensions methodsFor: 'extensions' stamp: 'StefanReichhart 7/21/2016 17:09'!
gtInspectorActionFor2: aGTExample
	^ GLMGenericAction new
		action: [ aGTExample inspect ];
		icon: GLMUIThemeExtraIcons glamorousInspect;
		title: 'Custom Inspect 2'! !

!GTDummyExamplesWithCustomExtensions methodsFor: 'extensions' stamp: 'StefanReichhart 7/21/2016 17:09'!
gtInspectorActionFor: anExample
	^ GLMGenericAction new
		action: [ anExample inspect ];
		icon: GLMUIThemeExtraIcons glamorousInspect;
		title: 'Custom Inspect'! !

!GTDummyExamplesWithCustomExtensions methodsFor: 'extensions' stamp: 'StefanReichhart 7/21/2016 15:16'!
gtInspectorFor: aComposite example1: aGTExample
	(aGTExample gtInspectorMethodIn: aComposite)
		title: 'Custom Extension 2'! !

!GTDummyExamplesWithCustomExtensions methodsFor: 'extensions' stamp: 'StefanReichhart 7/21/2016 15:16'!
gtInspectorFor: aComposite example2: aGTExample
	(aGTExample gtInspectorMethodIn: aComposite)
		title: 'Custom Extension 2'! !

!GTDummyExamplesWithCustomExtensions methodsFor: 'extensions' stamp: 'StefanReichhart 7/21/2016 15:16'!
gtSpotterStep: aStep example2: aGTExample
	aStep listProcessor
		title: 'Custom Extension 2 -- ' , aGTExample gtDisplayString;
		items: [ Array with: aGTExample ];
		itemName: [ :aSource | aSource gtDisplayString ];
		filter: GTFilterSubstring! !

!GTDummyExamplesWithCustomExtensions methodsFor: 'extensions' stamp: 'StefanReichhart 7/21/2016 15:16'!
gtSpotterStep: aStep example3: aGTExample
	aStep listProcessor
		title: 'Custom Extension 3 -- ' , aGTExample gtDisplayString;
		items: [ Array with: aGTExample ];
		itemName: [ :aSource | aSource gtDisplayString ];
		filter: GTFilterSubstring! !

!GTDummyExamplesWithCustomExtensions methodsFor: 'extensions' stamp: 'StefanReichhart 7/21/2016 15:16'!
gtSpotterStep: aStep example: aGTExample
	aStep listProcessor
		title: 'Custom Extension 1 -- ' , aGTExample gtDisplayString;
		items: [ Array with: aGTExample ];
		itemName: [ :aSource | aSource gtDisplayString ];
		filter: GTFilterSubstring! !

!GTDummyExamplesWithCustomExtensions methodsFor: 'examples' stamp: 'StefanReichhart 7/21/2016 15:11'!
inspectorExtension1
	<gtExample>
	<inspector: #gtInspectorFor:example1:>! !

!GTDummyExamplesWithCustomExtensions methodsFor: 'examples' stamp: 'StefanReichhart 7/21/2016 15:36'!
inspectorExtension2
	<gtExample>
	<inspectorClass: 'GTDummyExamplesWithCustomExtensions' selector: #gtInspectorFor:example1:>
	<inspector: #gtInspectorFor:example2:>! !

!GTDummyExamplesWithCustomExtensions methodsFor: 'examples' stamp: 'StefanReichhart 7/21/2016 17:07'!
inspectorExtension3
	<gtExample>
	<inspectorActionClass: 'GTDummyExamplesWithCustomExtensions' selector: #gtInspectorActionFor:>
	<inspectorAction: #gtInspectorActionFor2:>! !

!GTDummyExamplesWithCustomExtensions methodsFor: 'examples' stamp: 'StefanReichhart 7/21/2016 14:54'!
spotterExtension
	<gtExample>
	<spotterClass: 'GTDummyExamplesWithCustomExtensions' selector: #gtSpotterStep:example:>! !

!GTDummyExamplesWithCustomExtensions methodsFor: 'examples' stamp: 'StefanReichhart 7/21/2016 17:15'!
spotterExtension2
	<gtExample>
	<spotterClass: 'GTDummyExamplesWithCustomExtensions' selector: #gtSpotterStep:example:>
	<spotter: #gtSpotterStep:example2:>! !

!GTDummyExamplesWithCustomExtensions methodsFor: 'examples' stamp: 'StefanReichhart 7/21/2016 15:02'!
spotterExtension3
	<gtExample>
	<spotter: #gtSpotterStep:example3:>! !

GTAbstractDummyExamples subclass: #GTDummyExamplesWithDependencies
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Data'!

!GTDummyExamplesWithDependencies class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 13:03'!
a
	<gtExample>
	<label: 'Dummy #a'>
	<description: 'Dummy #a'>
	
	^ true! !

!GTDummyExamplesWithDependencies class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:08'!
b: aBoolean
	<gtExample>
	<label: 'Dummy #b:'>
	<description: 'Dummy #b:, depends: #a'>
	<dependsOn: #a> " aBoolean "
	
	^ aBoolean! !

!GTDummyExamplesWithDependencies class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:07'!
c: aBoolean1 c: aBoolean2
	<gtExample>
	<label: 'Dummy #c:c:'>
	<description: 'Dummy #c:c:, depends: #a and #b:'>
	<dependsOn: #a> " aBoolean1 "
	<dependsOn: #b:> " aBoolean2 "
	
	^ aBoolean1 & aBoolean2! !

!GTDummyExamplesWithDependencies class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:07'!
d: aBoolean1 d: aBoolean2 d: aBoolean3
	<gtExample>
	<label: 'Dummy #d:d:d:'>
	<description: 'Dummy #d:d:d:, depends: #a and #b: and #c:c:'>
	<dependsOn: #a> " aBoolean1 "
	<dependsOn: #b:> " aBoolean2 "
	<dependsOn: #c:c:> " aBoolean3 "
	
	^ aBoolean1 & aBoolean2 & aBoolean3! !

!GTDummyExamplesWithDependencies class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:07'!
e: aBoolean1 e: aBoolean2 e: aBoolean3 e: aBoolean4
	<gtExample>
	<label: 'Dummy #e:e:e:e:'>
	<description: 'Dummy #e:e:e:e:, depends: #a and #b: and #c:c: and #d:d:d:'>
	<dependsOn: #a> " aBoolean1 "
	<dependsOn: #b:> " aBoolean2 "
	<dependsOn: #c:c:> " aBoolean3 "
	<dependsOn: #d:d:d:> " aBoolean4 "
	
	^ aBoolean1 & aBoolean2 & aBoolean3 & aBoolean4! !

!GTDummyExamplesWithDependencies class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:07'!
f: aBoolean1 f: aBoolean2 f: aBoolean3
	" to have the same dependency more than once probably makes no sense at all, but it is technically valid. We don't make any constraints "
	<gtExample>
	<label: 'Dummy #f:f:f:'>
	<description: 'Dummy #f:f:f:, depends: #a and #a and #a'>
	<dependsOn: #a> " aBoolean1 "
	<dependsOn: #a> " aBoolean2 "
	<dependsOn: #a> " aBoolean3 "
	
	^ aBoolean1 & aBoolean2 & aBoolean3! !

!GTDummyExamplesWithDependencies class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:07'!
g: aBoolean1 g: aBoolean2 g: aBoolean3
	<gtExample>
	<label: 'Dummy #g:g:g:'>
	<description: 'Dummy #g:g:g:, depends: #a and #e:e:e:e: and #d:d:d:'>
	<dependsOn: #a> " aBoolean1 "
	<dependsOn: #e:e:e:e:> " aBoolean2 "
	<dependsOn: #d:d:d:> " aBoolean3 "
	
	^ aBoolean1 & aBoolean2 & aBoolean3! !

GTAbstractDummyExamples subclass: #GTDummyExamplesWithExceptions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Data'!

!GTDummyExamplesWithExceptions class methodsFor: 'examples 1' stamp: 'AndreiChis 12/4/2015 15:13'!
a
	<gtExample>
	<label: 'Dummy #a'>
	<description: 'Dummy #a, raises ZeroDivide'>
	<raises: #ZeroDivide>
	
	^ 1/0! !

!GTDummyExamplesWithExceptions class methodsFor: 'examples 1' stamp: 'StefanReichhart 9/12/2015 13:45'!
b
	<gtExample>
	<label: 'Dummy #b'>
	<description: 'Dummy #b, raises ZeroDivide'>
	<raises: #ZeroDivide>
	
	^ 1/0! !

!GTDummyExamplesWithExceptions class methodsFor: 'examples 1' stamp: 'StefanReichhart 9/12/2015 13:45'!
c
	<gtExample>
	<label: 'Dummy #c'>
	<description: 'Dummy #c, raises ZeroDivide'>
	<raises: 'ZeroDivide'>
	
	^ 1/0! !

!GTDummyExamplesWithExceptions class methodsFor: 'examples 2' stamp: 'AndreiChis 12/4/2015 15:13'!
d
	<gtExample>
	<label: 'Dummy #d'>
	<description: 'Dummy #d, raises ZeroDivide or AssertionFailure'>
	<raises: #ZeroDivide>
	<raises: #AssertionFailure>
	
	self assert: #( true false ) atRandom.
	^ 1/0! !

!GTDummyExamplesWithExceptions class methodsFor: 'examples 3' stamp: 'StefanReichhart 9/26/2015 11:26'!
e
	<gtExample>
	<label: 'Dummy #e'>
	<description: 'Dummy #e, raises an unexpected exception (AssertionFailure) since we did not a declare it'>
	<noTest>
	
	self assert: false! !

!GTDummyExamplesWithExceptions class methodsFor: 'examples 3' stamp: 'StefanReichhart 1/29/2017 14:07'!
f: anObject
	<gtExample>
	<label: 'Dummy #f'>
	<description: 'Dummy #f, depends: #b which raises an expected exception, returns nil'>
	<dependsOn: #b>
	
	self assert: anObject isNil! !

!GTDummyExamplesWithExceptions class methodsFor: 'examples 3' stamp: 'StefanReichhart 1/29/2017 14:07'!
g: anObject
	<gtExample>
	<label: 'Dummy #g'>
	<description: 'Dummy #g, depends: #e, should raise a dependency error since the only dependency is raising an exception'>
	<dependsOn: #e>
	<noTest>
	
	^ anObject! !

!GTDummyExamplesWithExceptions class methodsFor: 'examples 3' stamp: 'AndreiChis 12/4/2015 15:14'!
h
	<gtExample>
	<label: 'Dummy #h'>
	<description: 'Dummy #h, should raise an exception (by declaration) but it does not'>
	<raises: #AssertionFailure>
	<raises: #ZeroDivide>
	<noTest>
	
	self assert: true. " no exception raised -> expected exception not raises"
	true " no exception raised -> expected exception not raises "
		ifTrue: [ ^ 1 ] 
		ifFalse: [ 1/0 ]! !

GTAbstractDummyExamples subclass: #GTDummyExamplesWithExternalDependencies
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Data'!

!GTDummyExamplesWithExternalDependencies class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:12'!
a: aBoolean
	<gtExample>
	<label: 'Dummy #a:'>
	<description: 'Dummy #a:, depends: GTDummyExamples>>#a'>
	<dependsOnClass: 'GTDummyExamples class' selector: #a> 
	
	^ aBoolean! !

!GTDummyExamplesWithExternalDependencies class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:12'!
b: aBoolean1 b: aBoolean2
	<gtExample>
	<label: 'Dummy #b:b:'>
	<description: 'Dummy #b:b:, depends: GTDummyExamples>>#a and GTDummyExamples>>#b:'>
	<dependsOnClass: 'GTDummyExamples class' selector: #a> 
	<dependsOnClass: 'GTDummyExamples class' selector: #b:> 
	
	^ aBoolean1 & aBoolean2! !

!GTDummyExamplesWithExternalDependencies class methodsFor: 'examples' stamp: 'StefanReichhart 1/29/2017 14:12'!
c: aBoolean1 c: aBoolean2 c: aBoolean3
	<gtExample>
	<label: 'Dummy #c:c:'>
	<description: 'Dummy #c:c:c:, depends: GTDummyExamples>>#a and GTDummyExamples>>#b: and GTDummyExamplesWithDependencies>>#a'>
	<dependsOnClass: #'GTDummyExamples class' selector: #a> 
	<dependsOnClass: 'GTDummyExamples class' selector: #b:> 
	<dependsOnClass: 'GTDummyExamplesWithDependencies class' selector: #a>
	
	^ aBoolean1 & aBoolean2 & aBoolean3! !

GTAbstractDummyExamples subclass: #GTDummyExamplesWithGlobalSubjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Data'!

!GTDummyExamplesWithGlobalSubjects class methodsFor: 'examples' stamp: 'StefanReichhart 7/12/2016 10:38'!
classSideSubjects1
	<gtExample>
	
	self assert: self gtExampleContext example subjects first class = GTExampleClassSubject.
	self assert: self gtExampleContext example subjects first theClassName = 'GTExample'.
	self assert: self gtExampleContext example subjects first theClass = GTExample.
	self assert: self gtExampleContext example subjects first exists.
	
	^ 0! !

!GTDummyExamplesWithGlobalSubjects class methodsFor: 'examples' stamp: 'StefanReichhart 7/12/2016 10:37'!
classSideSubjects2
	<gtExample>
	
	self assert: self gtExampleContext example subjects first class = GTExampleClassSubject.
	self assert: self gtExampleContext example subjects first theClassName = 'GTExample'.
	self assert: self gtExampleContext example subjects first theClass = GTExample.
	self assert: self gtExampleContext example subjects first exists.
	
	^ 0! !

!GTDummyExamplesWithGlobalSubjects class methodsFor: 'config' stamp: 'StefanReichhart 7/4/2016 21:00'!
gtExamplesSubjects
	^ { GTExample }! !

!GTDummyExamplesWithGlobalSubjects methodsFor: 'config' stamp: 'StefanReichhart 7/4/2016 20:59'!
gtExamplesSubjects
	^ { Object. Array. GTExample >> #run. GTExample }! !

!GTDummyExamplesWithGlobalSubjects methodsFor: 'examples' stamp: 'StefanReichhart 7/12/2016 10:29'!
multipleSubjects1
	<gtExample>
	
	self assert: self gtExampleContext example subjects size = 4.
	self assert: (self gtExampleContext example subjects allSatisfy: [ :each | each exists ]).
	self gtExamplesSubjects do: [ :each |
		self assert: (self gtExampleContext example hasSubject: each asGTExampleSubject) ].
	
	^ 0! !

!GTDummyExamplesWithGlobalSubjects methodsFor: 'examples' stamp: 'StefanReichhart 7/12/2016 10:29'!
multipleSubjects2
	<gtExample>
	
	self assert: self gtExampleContext example subjects size = 4.
	self assert: (self gtExampleContext example subjects allSatisfy: [ :each | each exists ]).
	self gtExamplesSubjects do: [ :each |
		self assert: (self gtExampleContext example hasSubject: each asGTExampleSubject) ].
	
	^ 0! !

!GTDummyExamplesWithGlobalSubjects methodsFor: 'examples' stamp: 'StefanReichhart 7/12/2016 10:29'!
multipleSubjects3
	<gtExample>
	
	self assert: self gtExampleContext example subjects size = 4.
	self assert: (self gtExampleContext example subjects allSatisfy: [ :each | each exists ]).
	self gtExamplesSubjects do: [ :each |
		self assert: (self gtExampleContext example hasSubject: each asGTExampleSubject) ].
	
	^ 0! !

GTAbstractDummyExamples subclass: #GTDummyExamplesWithSubjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Data'!

!GTDummyExamplesWithSubjects methodsFor: 'examples' stamp: 'StefanReichhart 7/12/2016 10:10'!
classSubject
	<gtExample>
	<subjectClass: 'GTExample'>
	
	self assert: self gtExampleContext example subjects first class = GTExampleClassSubject.
	self assert: self gtExampleContext example subjects first theClassName = 'GTExample'.
	self assert: self gtExampleContext example subjects first theClass = GTExample.
	self assert: self gtExampleContext example subjects first exists.
	
	^ 0! !

!GTDummyExamplesWithSubjects methodsFor: 'examples' stamp: 'StefanReichhart 7/12/2016 10:08'!
helpSubject
	<gtExample>
	<subjectHelp: 'GT Inspector'>
	
	self assert: self gtExampleContext example subjects first class = GTExampleHelpSubject.
	self assert: self gtExampleContext example subjects first bookName = 'GT Inspector'.
	self assert: self gtExampleContext example subjects first title isNil.
	self assert: self gtExampleContext example subjects first topic notNil.
	
	^ 0! !

!GTDummyExamplesWithSubjects methodsFor: 'examples' stamp: 'StefanReichhart 7/12/2016 10:08'!
helpSubjectWithTitle
	<gtExample>
	<subjectHelp: 'GT Inspector' title: 'Roassal'>
	
	self assert: self gtExampleContext example subjects first class = GTExampleHelpSubject.
	self assert: self gtExampleContext example subjects first bookName = 'GT Inspector'.
	self assert: self gtExampleContext example subjects first title = 'Roassal'.
	self assert: self gtExampleContext example subjects first topic notNil.
	
	^ 0
	! !

!GTDummyExamplesWithSubjects methodsFor: 'examples' stamp: 'StefanReichhart 8/13/2016 13:05'!
keywordsSubject
	<gtExample>
	<subjectKeywords: #( 'Justo' 'Malesuada' 'Bibendum' 'Adipiscing' 'Elit' )>
	<subjectKeyword: 'Tristique'>
	
	self assert: self gtExampleContext example subjects first class = GTExampleKeywordSubject.
	self assert: self gtExampleContext example subjects size = 6.
	self assert: (self gtExampleContext example subjects collect: [ :each | each keyword ]) asSet = #( 'Justo' 'Malesuada' 'Bibendum' 'Adipiscing' 'Elit' 'Tristique' ) asSet.
	
	^ 0! !

!GTDummyExamplesWithSubjects methodsFor: 'examples' stamp: 'StefanReichhart 7/12/2016 10:10'!
metaclassSubject
	<gtExample>
	<subjectClass: 'GTExample class'>

	self assert: self gtExampleContext example subjects first class = GTExampleClassSubject.
	self assert: self gtExampleContext example subjects first theClassName = 'GTExample class'.
	self assert: self gtExampleContext example subjects first theClass = GTExample class.
	self assert: self gtExampleContext example subjects first exists.
	
	^ 0! !

!GTDummyExamplesWithSubjects methodsFor: 'examples' stamp: 'StefanReichhart 7/12/2016 10:11'!
metaclassSubjectBySymbol
	<gtExample>
	<subjectClass: #'GTExample class'>
	
	self assert: self gtExampleContext example subjects first class = GTExampleClassSubject.
	self assert: self gtExampleContext example subjects first theClassName = 'GTExample class'.
	self assert: self gtExampleContext example subjects first theClass = GTExample class.
	self assert: self gtExampleContext example subjects first exists.
	
	^ 0! !

!GTDummyExamplesWithSubjects methodsFor: 'examples' stamp: 'StefanReichhart 8/13/2016 12:27'!
multipleSubjects
	<gtExample>
	<subjectClass: 'GTExample' selector: #methodClass>
	<subjectClass: #GTExample selector: #selector>
	<subjectClass: 'GTExample class' selector: #selector> " does not exist "
	<subjectClass: #GTExample selector: #run>
	<subjectHelp: 'GT Inspector'>
	<subjectClass: 'GTExample'>
	<subjectText: 'Justo Malesuada Bibendum Adipiscing Elit'>
	<subjectText: 'Donec sed odio dui'>
	<subjectKeywords: #( 'Donec' 'sed' 'odio' 'dui' )>
	<subjectKeyword: 'Malesuada'>
	
	self assert: self gtExampleContext example subjects size = 13.
	self assert: (self gtExampleContext example subjects select: [ :each | each exists ]) size = 12.
	
	^ 0! !

!GTDummyExamplesWithSubjects methodsFor: 'examples' stamp: 'StefanReichhart 7/12/2016 10:11'!
packageSubject
	<gtExample>
	<subjectPackage: 'GT-Examples'>

	self assert: self gtExampleContext example subjects first class = GTExamplePackageSubject.
	self assert: self gtExampleContext example subjects first thePackageName = 'GT-Examples'.
	self assert: self gtExampleContext example subjects first thePackage notNil.
	self assert: self gtExampleContext example subjects first exists.
	
	^ 0! !

!GTDummyExamplesWithSubjects methodsFor: 'examples' stamp: 'StefanReichhart 7/12/2016 10:51'!
tagSubject
	<gtExample>
	<subjectTag: 'GT-Examples-Dummies-Data'>
	
	self assert: self gtExampleContext example subjects first class = GTExampleTagSubject.
	self assert: self gtExampleContext example subjects first theTagName = 'GT-Examples-Dummies-Data'.
	self assert: self gtExampleContext example subjects first theTag notNil.
	self assert: self gtExampleContext example subjects first thePackage notNil.
	self assert: self gtExampleContext example subjects first exists.
	
	^ 0! !

!GTDummyExamplesWithSubjects methodsFor: 'examples' stamp: 'StefanReichhart 7/12/2016 10:51'!
tagSubjectShortened
	<gtExample>
	<subjectTag: 'Data'>

	self assert: self gtExampleContext example subjects first class = GTExampleTagSubject.
	self assert: self gtExampleContext example subjects first theTagName = 'Data'.
	self assert: self gtExampleContext example subjects first theTag notNil.
	self assert: self gtExampleContext example subjects first thePackage notNil.
	self assert: self gtExampleContext example subjects first exists.
	
	^ 0! !

!GTDummyExamplesWithSubjects methodsFor: 'examples' stamp: 'StefanReichhart 8/13/2016 11:58'!
textSubject
	<gtExample>
	<subjectText: 'Justo Malesuada Bibendum Adipiscing Elit'>
	
	self assert: self gtExampleContext example subjects first class = GTExampleTextSubject.
	self assert: self gtExampleContext example subjects first text = 'Justo Malesuada Bibendum Adipiscing Elit'.
	self assert: self gtExampleContext example subjects first exists.
	
	^ 0! !

GTAbstractDummyExamples subclass: #GTDummyExamplesWithSubjectsAndGlobalSubjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Data'!

!GTDummyExamplesWithSubjectsAndGlobalSubjects methodsFor: 'config' stamp: 'StefanReichhart 7/12/2016 10:34'!
gtExamplesSubjects
	^ { Object. Array. GTExample }! !

!GTDummyExamplesWithSubjectsAndGlobalSubjects methodsFor: 'examples' stamp: 'StefanReichhart 7/12/2016 10:34'!
multipleSubjects1
	<gtExample>
	<subjectClass: 'GTExample' selector: #methodClass>
	<subjectClass: #GTExample selector: #selector>
	
	self assert: self gtExampleContext example subjects size = 5.
	self assert: (self gtExampleContext example subjects select: [ :each | each exists ]) size = 5.
	
	^ 0! !

!GTDummyExamplesWithSubjectsAndGlobalSubjects methodsFor: 'examples' stamp: 'StefanReichhart 7/12/2016 10:35'!
multipleSubjects2
	<gtExample>
	<subject: 'GTExample'> " overlap "
	<subjectClass: 'Object'> " overlap "
	<subjectClass: #Array> " overlap "
	<subjectClass: 'GTExample' selector: #methodClass>
	<subjectClass: #GTExample selector: #selector>
	
	self assert: self gtExampleContext example subjects size = 5.
	self assert: (self gtExampleContext example subjects select: [ :each | each exists ]) size = 5.
	
	^ 0! !

Object subclass: #GTDummyExampleSource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Data'!

!GTDummyExampleSource methodsFor: 'dummy-behaviour' stamp: 'StefanReichhart 9/12/2015 18:17'!
a
	" imagine this would be some real stuff "
	^ true! !

!GTDummyExampleSource methodsFor: 'dummy-behaviour' stamp: 'StefanReichhart 9/12/2015 18:17'!
b
	" imagine this would be some real stuff "
	^ false! !
